
package jmsdemo;

import java.io.IOException;
import javax.inject.Inject;
import javax.websocket.CloseReason;
import javax.websocket.EndpointConfig;
import javax.websocket.OnClose;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.ServerEndpoint;

@ServerEndpoint("/compute")
public class ComputeWebsocket 
{
    @Inject
    Jmsdemo demo;

    Session mySession;
    
    @OnOpen
    public void open(Session session, EndpointConfig conf) 
    { 
        demo.setWebsocketReference(this);
        mySession = session;
    }

    @OnClose
    public void close(Session session, CloseReason reason) 
    { 
        demo.removeWebsocketReference(this);
    }
    
    void reply(String result)
    {
        try {
            mySession.getBasicRemote().sendText(result);
        } catch (IOException e) {}
    }
    
}
