package jmsdemo;

import java.io.Serializable;
import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;
import javax.jms.JMSContext;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Topic;
import javax.jms.TopicConnectionFactory;


@Named("jmsdemo")
@SessionScoped
public class Jmsdemo implements Serializable
{
    private int a;
    private int b;
    private int op;
    
    private String status;
    private String result;
    
    @Resource(lookup = "jms/topicfactory")
    private TopicConnectionFactory connectionFactory;

    @Resource(lookup = "jms/topic")
    private Topic topic;
    
    @Inject
    ListOfPendingComputes appBean;
    
    JMSContext context;
    
    String originalMsgId;
    ComputeWebsocket wsRef;
     
    public Jmsdemo() 
    {
        status = "Welcome! Enter the details of your calculation task, and submit it for computation.";
    }
    
    @PostConstruct
    void init()
    {
        context = connectionFactory.createContext();
    }
    
    void setWebsocketReference(ComputeWebsocket ws)
    {
         wsRef = ws;
         if (originalMsgId != null)
            appBean.addMsgIdtoWs(originalMsgId, ws);
         originalMsgId = null;
    }
    
    void removeWebsocketReference(ComputeWebsocket aThis) 
    {
        appBean.removeWsRef(wsRef);
    }
    
    public String getA() {  return Integer.toString(a);  }
    public void setA(String newa) {  a = Integer.parseInt(newa);  }

    public String getB() {  return Integer.toString(b);  }
    public void setB(String newb)  {  b = Integer.parseInt(newb);  }
    
    public String getOp() {  return Integer.toString(op);  }
    public void setOp(String newop)  {  op = Integer.parseInt(newop);  }

    public String getResult() {  return result;  }
    public void setResult(String newResult)  {  result = newResult;  }

    public String getStatus() {  return status;  }
    public void setStatus(String newStatus)  {  status = newStatus;  }

    public void compute() 
    {       
        try {
            sendTask(a + ";" + b + ";" + op);
        } catch (JMSException ex) {
            status = ex.getLocalizedMessage();
            return;
        }
       status = "Task submitted. Waiting for evaluation.";
       result = "?";
    }
    
    private void sendTask(String task) throws JMSException
    {
        Message msg = context.createTextMessage(task);                        
        msg.setStringProperty("Direction", "ToServer");
        context.createProducer().send(topic, msg);     
        originalMsgId = msg.getJMSMessageID();       
    }
}
