
package jmsdemo;

import java.util.HashMap;
import java.util.Map;
import javax.inject.Named;
import javax.enterprise.context.ApplicationScoped;

@Named(value = "listOfPendingComputes")
@ApplicationScoped
public class ListOfPendingComputes 
{
    Map<String, ComputeWebsocket> msgToWs;
    
    public ListOfPendingComputes() 
    {
        msgToWs = new HashMap<>();
    }

    void addMsgIdtoWs(String msgId, ComputeWebsocket wsRef) 
    {
        msgToWs.put(msgId, wsRef);
    }
    
    void removeWsRef(ComputeWebsocket wsRef)
    {
        for (Map.Entry<String, ComputeWebsocket> e : msgToWs.entrySet())
            if (e.getValue() == wsRef)
            {
                msgToWs.remove(e.getKey());
                break;
            }
    }

    void reply(String originalMsgId, String result) 
    {
        ComputeWebsocket ws = msgToWs.get(originalMsgId);
        if (ws != null)  ws.reply(result);
    }
    
}
